  100 REM --------------------------------------------------------------------
  110 REM Function: BBC Basic program; BBC Micro end of two program suite
  120 REM           used to transfer files via a serial cable
  130 REM Version:  1.0B
  140 REM Dates:    Begun:         10 October 1986
  150 REM           Last addition: 15 October 1986
  160 REM Author:   Peter Smith
  170 REM Remarks:  Sets serial input baud rate to 1200
  180 REM           Key f0 transmit SPACE if Nimbus end is locked
  190 REM --------------------------------------------------------------------
  200 MODE 0
  210 PRINT ''"FILE TRANSFER -- BBC Micro to RM Nimbus"
  220 PRINT   "                 Version 1.0B"''
  230 CLOSE#0
  240 *KEY0 *FX3,3|MVDU32|M*FX3,0|M
  250 REM -----------           Initialize values
  260 VDU 15
  270 *FX 6,10
  280 *FX 5,2
  290 *FX 8,4
  300 INPUT "File name for transfer: ",A$
  310 FIN=OPENIN(A$):IF FIN=0 THEN PRINT "Unable to open file":GOTO 300
  320 PROCcount_bytes
  330 :
  340 PRINT''"Ready to transmit to the Nimbus"
  350 PRINT "Press SPACE when Nimbus is ready";:REPEAT:X$=GET$:UNTIL X$=" "
  360 PRINT ''"Transferring ";A$
  370 FIN=OPENIN(A$)
  380 *FX 3,3
  390 CNT=0
  400 VDU lobyte
  410 VDU hibyte
  420 IF lobyte+256*hibyte<45000 THEN 460
  430 *FX3,0
  440 PRINT "File to large to transfer - ABORTING"':CLOSE#0:END
  450 :
  460 REPEAT:N=BGET#FIN
  470 VDU N
  480 CNT=CNT+1
  490 IF N=13 FOR I%=1 TO 400:NEXT I%
  500 UNTIL EOF # FIN
  510 :
  520 CLOSE # 0
  530 *FX 3,0
  540 PRINT ''"Finished transferring ";A$
  550 PRINT "Bytes transferred: "CNT
  560 PRINT ''
  570 END
  580 :
  590 DEF PROCcount_bytes
  600 PRINT ''"Checking size of file"
  610 n=0
  620 REPEAT:N=BGET#FIN
  630 n=n+1
  640 UNTIL EOF#FIN
  650 :
  660 CLOSE#FIN
  670 lobyte=n AND &FF
  680 hibyte=(n AND &0FF00) DIV &FF
  690 :
  700 ENDPROC
